/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */


// #include <stdio.h>
#include <unistd.h>
// #include <stdlib.h>
// #include <dlfcn.h>
#include <memcheck.h>

extern char *static_var;

static char haha[]="x";
char uninit[1];
char hahalong[100]="kasldjkasdlf";

typedef struct teststruct {
  char b1;
  int i;
  char b2;
  double d;
  char b3;
  float f;
  long long l;
  char b4;
  } xxx;

#define TestSize 10
// test cross heap block
void malloctest() {
  int i, j;
  char *mem, c;
  char* memarray[TestSize];

  for (i=0; i<TestSize; i++) {
    printf("malloctest: allocating %d of %d\n", i+1, TestSize);
    mem=(char*)malloc(1000000+i);
    memarray[i]=mem;
    for (j=999009; j<1000000; j++) {
      mem[j+i]='A'; //init
      c=mem[j+i]; // read
      }
    }
  for (i=0; i<TestSize; i++) {
    printf("malloctest: freeing %d of %d\n", i+1, TestSize);
    free(memarray[i]);
    }
  }

void wraptest() {
  time_t timeGMT;
  struct tm* timeLOCAL;
  char sTime[20];

  time( &timeGMT );
  timeLOCAL = localtime( &timeGMT );
  strftime( sTime, sizeof(sTime), "%Y-%m-%d %H:%M:%S", timeLOCAL );
  printf("formatted time: %s\n", sTime);
  }

// test, if rights are handled ok on realloc
void realloctest() {
  char *mem, c;
  int i, j;
  mem=(char*)malloc(100);
  // init 100 bytes:
  for (i=0; i<100; i++) mem[i]='A';
  for (j=0; j<10; j++) {
    mem=(char*)realloc(mem, 100+j+1);
    // read 100 bytes:
    for (i=0; i<100; i++) c=mem[i];
    }
  free(mem);
  }
void wo_to_ro_test() {
  char *mem, c;
  int i;

  mem=malloc(10);
  chkr_check_addr(mem, 10, MCWO);
  for (i=0; i<10; i++) {
    fprintf(MCOUT, "wo_to_ro_test, i: %d\n", i);
    c=mem[i];
    }
  chkr_set_right(mem, 10, MCWO);
  chkr_check_addr(mem, 10, MCWO);
  for (i=0; i<10; i++) {
    mem[i]=10;
    }
  chkr_set_right(mem, 10, MCUN);
  chkr_set_right(mem, 10, MCRW);
  for (i=0; i<10; i++) {
    mem[i]=10;
    }
  free(mem);
  }
// test, if rights are handled ok on realloc
struct teststruct structtest(int n) {
  struct teststruct data;
  struct teststruct data2;
  printf("teststruct called %lx %d\n", (ulong)&data, n);
  data.b1=data.b2=data.b3=data.b4=0xff;
  data.i=data.l=0;
  data.d=data.f=0.0;
  // memset(&data, 0, sizeof(data)); // fill pad bytes also ...
  printf("teststruct copy %lx --> %lx\n", (ulong)&data, (ulong)&data2);
  data2=data;
  if (n>0)
    return structtest(n-1);
  else
    return data2;
  }

void test5() {
  FILE *str;
  char *buf;
  int exitstatus=0;

  static char x[55];
  // strcpy (x, "hifans");
  x[0]='\0';
  strcat(x, "hi fansadf ");

  // ok strcat(x, "hi fansadf ljkasdflkjasdfkasjdfasdkfjasdfkjasdfkjasdflaskdjfasldkfjsdlfkjsadflkjasdflkjsadflaksj");

  buf=(char*)malloc(1000);
#ifdef MEMCHECKDEBUG
  sprintf(buf, "../../include/memcheck.h");
#else
  sprintf(buf, "../include/memcheck.h");
#endif
  str=fopen(buf, "r");
  if (str==NULL) {
    fprintf(stderr, "in test5: can't open: '%s'\n", buf);
    exit(1);
    }
  fgets(buf, 10, str);
  strncpy(x, buf, 20);
  free(buf);

  buf=malloc(19);
  fscanf(str, "%18s", buf);
  strlen(buf);
  free(buf);
  }

void test4() {
  long long i=256*256;
  char c[55]="hi fansjada d flakdjf adfkafdakfdafdkfd afdjkdsafajsd";
  i=5;
  c[0]='\n';
  }

int test3() {
  char xxx='x';
  // char *haah="asldjfaldjal";
  char *s, *ss, *del;
  int  i, a;

 
  void *(*ptr)(size_t);
  void *(*mallvar)(size_t)=malloc;
  void *(*freevar)(size_t)=malloc;
  fprintf(stderr, "test3 start ...\n");

  // wird dieses stmt nicht ausgefuehrt muss ein error erfolgen, nicht initialisiert: 
  i=2;
  a=5*i;
  fprintf(stderr, "test3 xxx: %lx\n", (ulong)&xxx);

  s=(char*)calloc(50, 1);
  // strlen(s);
  // strcpy(s, "-hssldf  sjfsadhfshdfsadfsdafhhahhahhahhahhahhahhahhahhahhahhah----");
  strcpy(s, s); /* duerfte nix kopiert werden, da 0 */

  hahalong[50]='\0';
  strlen(hahalong);

  uninit[0]='a';
  uninit[1]='a';
  uninit[2]='a';
  uninit[3]='a';
  haha[3]='a';
  // ok, strlen(uninit);
  // ok strcpy(haha, uninit);
  // ok, strcmp(haha, uninit);
  // liest das ende von uninit, ok strcmp(uninit, haha);
  // RO, ok strcpy(static_var, haha);
  // RO, ok, strncpy(static_var, haha, 1);

  mallvar=NULL;
  freevar=NULL;
  // ok, free(NULL);
  // ok, strlen(freevar);
  // ok, strcpy(freevar, freevar);
  // strcmp(freevar, freevar);
  // copy in static area, ok strcpy("hi", haha);

  // uninitialisierung:
  // quelle nicht initialisiert, ok strlen(haha);
  // string zu lang, ok strcpy(haha, hahalong);

  del=(char*)malloc(5);  
  printf("mem-addr: %lx\n", (long)del);
  // ok free(del-1);
  // free(del);
  free(del);
  // ok, freigegebener bereich del[-2]='R';
  // ok, freigegebener bereich del[20]='R';

  free(s);
  s=(char*)malloc(5);
  ptr=malloc;
  // ok, zu lang, strcpy(s, "-----");
  // s[7]='R';
  //s[-2]='E';
  free(s);
  s=(char*)calloc(2, 1);

  printf("loop ...\n");
  for (i=0; i<7; i++) {
     ss=(char*)malloc(12310+i);  
     // sleep(1);
     free(ss);
     }

  printf("vor realloc: %ld\n", (long)s);
  s=(char*)realloc(s, 10000);
  printf("vor free 1: %ld\n", (long)s);
  free(s);
  
  // printf("vor free 2: %ld\n", (long)s);
  s=(char*)malloc(11);  
  sprintf(s, "1234");
  sprintf(s, "%4ld", 9);
  printf("sprintf: %s\n", s);
  sprintf(s, "%*ld", 10, 9);
  printf("sprintf: %s\n", s);
  sprintf(s, "%*d", 10, 9);
  printf("sprintf: %s\n", s);
  sprintf(s, "%4d", 9);
  printf("sprintf: %s\n", s);
  sprintf(s, "%*hd", 10, 9);
  printf("sprintf: %s\n", s);
  sprintf(s, "%4hd", 9);
  printf("sprintf: %s\n", s);
  sprintf(s, "%*lf", 10, (float)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%1.8lf", (float)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%1.8lf", (double)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%*.*lf", 1, 8, (double)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%1.8lf", (double)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%*f", 10, (float)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%1.8f", (float)1.0/3.0);
  printf("sprintf: %s\n", s);
  sprintf(s, "%f", (float)1.0/3.0);
  sprintf(s, "%.4s", "abcdelonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglongf");
  printf("sprintf: %s\n", s);
  sprintf(s, "%.*s", 4, "abcdelonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglonglongf");
  printf("sprintf: %s\n", s);
  sprintf(s, "%s", "abcdef");
  // s[5]='A';
  free(s);
  return 0;
  }


int main(int argc, char **argv) {
  struct teststruct d;
  int i;
  void *ptr, *handele;
  char *cptr;

  printf("adfkadlffa smain argc, argv %lx, %lx\n", (ulong)&argc, (ulong)argv);

#if defined(__CYGWIN__)
  printf("main impure: %lx\n", (ulong)_impure_ptr);
  printf("main impurestdout: %lx\n", (ulong)_impure_ptr->_stdout);
#endif

  ptr=stdout;
  handele=stdout;
  printf("stdout: %lx\n", (ulong)handele);

  cptr=(char*)0x10815;
  // *cptr='a';
  // free(cptr);

  // access argc:
  i=argc;
  for (i=0; i<argc; i++)
    // access argv:
    printf(argv[i]);
  test5();
  test3();
  test4();
  ptr=test4;
  // ptr();
  printf("doing structtest ...\n");
  d=structtest(100);
  printf("teststruct.i: %d\n", d.i);
  printf("teststruct.i: %f\n", d.d);
  wo_to_ro_test();
  wraptest();
  realloctest();
  malloctest();
  return 0;
  }

