/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */


#include <memcheck.h>
#include <stdio.h>
#include <unistd.h>
// #include <stdlib.h>
#include <dlfcn.h>

static char haha[]="xxxx";
// add some bss data:
int inbss;

extern int test_lib(int);

void test_memmove() {
  void *m, *m2;
  int i;

  m=malloc(997);
  m2=malloc(999);
  // init m:
  memset(m, 0, 997);
  for (i=987; i<998; i++)
    memmove(m2, m, i);
  free(m);
  free(m2);
  }

void test_gethostname() {
  char buf[1000];

  if (gethostname(buf, 1000)) {
    printf("gethostname failed\n");
    exit(1);
    }
  else {
    printf("result gethostname %s\n", buf);
    }
  }

int main(int argc, char **argv) {
  char *str;
  int  i;
  double d;
  long double ld;

  str=(char*)malloc(20);
  printf("main called ...\n");

  sprintf(str, "%d %c", 4999, 'a');

  // for (i=0; str[i]!='\0'; i++); // read test

  printf("str is: '%s'\n", str);

  fprintf(stderr, "scan %d args\n", sscanf(str, "%d", &i));
  printf("i is: '%d'\n", i);

  sprintf(str, "%08x", 0xabcd);
  printf("str is: '%s'\n", str);
  fprintf(stderr, "scan %d args\n", sscanf(str, "%x", &i));
  printf("i is: '%x'\n", i);

  sprintf(str, "%.2g", 0.1234567);
  printf("str is: '%s'\n", str);
  fprintf(stderr, "scan %d args\n", sscanf(str, "%lg", &d));
  printf("d is: '%g'\n", d);



  sprintf(str, "%s\\%1i", "haha", 99);
  printf("str is: '%s'\n", str);

  sscanf("0.1234", "%Lf", &ld);
  printf("ld: %Lf\n", ld);
  str=malloc(11);
  printf("count lfs: %d\n", sscanf("0.1234", "%Lf%10s", &ld, str));
  printf("str: '%s'\n", str, strlen(str));
  ld=11.123;
  sprintf(str, "%.0Lf", ld);
  printf("str is: '%s'\n", str);

  str=malloc(13);
  i=sscanf("1234567890 @some string", "%d %[^\013]12s", &i, str);
  if (i>0) printf("str is: '%s', len: %d\n", str, strlen(str));
  else mcabort("error on sscanf!");

  free(strdup(str));

  test_lib(33);
  test_memmove();
  test_gethostname();

  exit(0);
  }

/*
void *get_impure_ptr() {
  return (void*)_impure_ptr;
  }
*/





