/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */
// rename puplic functions

#ifndef _debugrename_h_
#define _debugrename_h_

// rename defines
#undef MCOUT
#define MCOUT stdout
#undef BCMOUT
#define BCMOUT MCOUT
#undef mcglobal
#define mcglobal debmcglobal
#undef mcglobalP
#define mcglobalP debmcglobal_ptr
#undef MCMAINSHADOW
#define MCMAINSHADOW 1000000
#undef  MCHeapBlock
#define MCHeapBlock (0x400000)       /* 4 meg */
#undef  MCBMSIZE
#define MCBMSIZE  0x100000            /* 4 meg / 4 = 1 meg */
#undef  MCHeapSegments
#define MCHeapSegments 1024       /* 4 gigs */

// rename public functions for main and libpart
#define MemCheckInit debMemCheckInit
#define MemCheckClose debMemCheckClose
#define setMCGlobalPtr debsetMCGlobalPtr
#define getMCGlobalPtr debgetMCGlobalPtr
#define print_location debprint_location
#define load_libs debload_libs
#define check_free debcheck_free
#define check_allocs debcheck_allocs
#define printall debprintall
#define mcabort debmcabort
#define get_env_int debget_env_int
#define get_symtab debget_symtab
#define get_env_string debget_env_string
#define comp_rights_fast debcomp_rights_fast
#define check_abort debcheck_abort
#define list_find deblist_find
#define get_sym debget_sym
// #define getbp debgetbp
#define cpBm debcpBm
#define checknull debchecknull

#define mc_get_impure_ptr debmc_get_impure_ptr

#define MCMalloc debMCMalloc
#define MCFree debMCFree
#define MCRealloc debMCRealloc
#define MCCalloc debMCCalloc
#define MCStrncpy debMCStrncpy
#define MCStrcmp debMCStrcmp
#define MCStrcat debMCStrcat
#define MCStrcpy debMCStrcpy
#define MCStrlen debMCStrlen
#define MCFgets debMCFgets
#define MCMalloc_NoInfo debMCMalloc_NoInfo
#define MCFree_NoInfo debMCFree_NoInfo
#define MCRealloc_NoInfo debMCRealloc_NoInfo
#define MCCalloc_NoInfo debMCCalloc_NoInfo
#define MCFgets_NoInfo debMCFgets_NoInfo
#define MCStrlen_NoInfo debMCStrlen_NoInfo
#define MCStrcpy_NoInfo debMCStrcpy_NoInfo
#define MCStrcat_NoInfo debMCStrcat_NoInfo
#define MCStrncpy_NoInfo debMCStrncpy_NoInfo
#define MCStrcmp_NoInfo debMCStrcmp_NoInfo

// rename functions and function pointers in bcm:
#define mallocptr debmallocptr
#define reallocptr debreallocptr
#define freeptr debfreeptr
#define logptr deblogptr
#define setLogFunction debsetLogFunction
#define bcmInit debbcmInit
#define BCMMalloc debBCMMalloc
#define BCMFree debBCMFree
#define BCMRealloc debBCMRealloc
#define uncheckedMalloc debuncheckedMalloc
#define uncheckedRealloc debuncheckedRealloc
#define uncheckedFree debuncheckedFree
#define BCMCalloc debBCMCalloc
#define defaultLog debdefaultLog
#define randomSet debrandomSet
#define checkMemoryBlock debcheckMemoryBlock
#define bCheckedMalloc debbCheckedMalloc

// rename checker.c functions:

#if defined(DEBUGMAIN)
  #include <main_a_b.h>
  // application main is renamed to debmain, rename it to debappmain
  // is called from debuglib
  #define main debappmain
#else
  // rename public functions, only libpart
  #define chkr_set_right debchkr_set_right
  #define chkr_check_addr debchkr_check_addr
  #define chkr_copy_bitmap debchkr_copy_bitmap
  #define chkr_check_exec debchkr_check_exec
  #define chkr_check_str debchkr_check_str
  #define checkStack debchkr_checkStack
  #define checkStackWrite debchkr_checkStackWrite
  #define check_printf_format debchkr_check_printf_format
  #define vsscanf debchkr_vsscanf

  #include <lib_b_c.h>
  // handle main, __wrap_main in debuglib is renamed to debmain
  // rename it to __real_main, so it gets called by the checker
  // #define debmain main
  #define __wrap_main main
  // the call to __real_main in the debuglib is renamed to main,
  // rename it to debappmain, so the application main is called
  // by the debuglib
  // #define main debappmain
  #define __real_main debappmain
#endif


#endif
