/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */

#if !defined(__mc_ucl_h__)

// #include <stdio.h>
// #include <dlfcn.h>
// #include <sys/mman.h>
// #include <assert.h>
// #include <errno.h>
// #include <asm/param.h> // pagesize

#define OPCCALL 0xe8

// note: struct func_code is written over trapped functions, so 
// function size is important. Should be no prob since gcc seems 
//to align functions at 16 bit boundaries (fill bytes after ret insn).
#define UCLJUPMPOFS 5 // opcode + reladr
struct func_code {
	// unsigned char push1;
	// unsigned short mov1;
	unsigned char opcode;
	int	reladr;
	unsigned int func_info_ptr;	// used to pass address of func_info from
				// instrument_fun to trap
} __attribute__ ((packed));

struct frame_ovl {
	unsigned int prev_frame; // pushed bp of caller
	unsigned int ret; // return addr of us
} __attribute__ ((packed));

struct func_info {
	struct func_code *fun_code;	// the saved func code
	unsigned int fun_addr;		// start address
	unsigned int fun_ret;		// saved return address
	int check;			// status should function be checked
};

#define UCLFUNCSTACSIZE 1024

// static void ucl_pushfunc(struct func_info *f) {
// static struct func_info *ucl_popfunc(int remove) {
// static void ucl_endtrap();
// static void ucl_trap() {
// static void ucl_endtrap() {
void ucl_instrument_func(void *fun);
#endif
