/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */
/*
 * Source for libbcmmain, define some globally variables.
 */

#include <stdio.h>
#include <bcm/bcm.h>

#if defined(BCM_FOR_MC)
  #include <memcheck.h>
#endif

#if defined(WIN32) && ! defined(__CYGWIN__)
  // native win32
  extern void *realmallocFirst(size_t);
  extern void *realreallocFirst(void *, size_t);
  extern void realfreeFirst(void *);
  BCMMAIN_API void * (*realmallocptr) (size_t)=realmallocFirst;
  BCMMAIN_API void (*realfreeptr) (void *)=realfreeFirst;
  BCMMAIN_API void * (*realreallocptr) (void*, size_t)=realreallocFirst;
#endif

BCMMAIN_API void * (*mallocptr) (size_t, char *, int)=uncheckedMalloc;
BCMMAIN_API void * (*reallocptr) (void *, size_t, char *, int)=uncheckedRealloc;
BCMMAIN_API void (*freeptr) (void *, char *, int)=uncheckedFree;
BCMMAIN_API void (*logptr) (char *)=defaultLog;





