/**********************************************************************
***********************************************************************/

#include <stdio.h>
#include <assert.h>
#include "../include/memcheck.h"


class MemCheck {
public:
  MemCheck();
  ~MemCheck();
  };

// this way we are initialized before main:
// Note: works only if linked before other c++ libraries (libstdc++)
static MemCheck unused_global_memcheck_var;

MemCheck::MemCheck() {
  // char *progname;

  // if (mcget_progname()==NULL) {
    // if ((progname=get_env_string("MCPROGNAME", NULL))==NULL) {
      // // we need a progname here to get dependency libs and there
      // // symbols !
      // fprintf(stderr,"_init not called and env-var MCPROGNAME not set !\n");
      // assert(0);
      // }
    // }
  // mcset_progname(progname);
  MemCheckInit();
  fprintf(stderr, "MemCheck() constructor called\n");
  }
MemCheck::~MemCheck() {
  fprintf(stderr, "MemCheck() destructor called\n");
  MemCheckClose(0);
  }

void *operator new (size_t sz) {
  // fprintf(stderr, "MemCheck new() 1 called\n");
  return MCMalloc(sz, "operator new", 0);
  }

void *operator new[] (size_t sz) {
  // fprintf(stderr, "MemCheck new() 2 called\n");
  return MCMalloc(sz, "operator new", 0);
  }

void operator delete (void *_p) {
  // fprintf(stderr, "MemCheck delete() 1 called\n");
  MCFree(_p, 0, "operator delete", 0);
  }

void operator delete[] (void *_p) {
  // fprintf(stderr, "MemCheck delete() 2 called\n");
  MCFree(_p, 0, "operator delete", 0);
  }


