/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */


#include <stdio.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include "memcheck.h"

#if defined(AIXV3) || defined(hpux)
  extern char * sys_errlist[];
#endif

int main() {
  int shmid;
  int key;
  int * command, i;

  key=MCSHMKEY;
  if ((shmid=shmget((key_t)key, sizeof(int), 0))<0) {
    fprintf(stderr, "mmon: can't get shared memory\n");
    fprintf(stderr, "sys_errlist: %s\n", sys_errlist[errno]);
    }
  command=(int*)shmat(shmid, NULL, 0);
  if ((command==NULL) || (command==(int*)-1)) {
    fprintf(stderr, "mmon: can't attach shared memory\n" );
    fprintf(stderr, "sys_errlist: %s\n", sys_errlist[errno]);
    exit( -1 );
    }

    printf("command ?\n");
    fscanf(stdin, "%d", command);
    printf("command is: %d\n", *command);

  }


